# Mirskyho a Dilworthova věta

**Věta** (Dilworthova)
- Nechť $\mathcal P = (X, P)$ POSET a $\text{width}(\mathcal P) = w$.
- Pak existuje rozklad množiny $X, X = C_{1} \cup C_{2} \cup \dots \cup C_{w}$, kde $C_{i}, i = 1 \dots, w$ je řetězec.
- Navíc, neexistuje rozklad množiny $X$ na méně než $w$ řetězců.

**Věta** (Mirskyho, duální Dilworthova)
- Nechť $\mathcal P = (X, P)$ POSET a $\text{height}(\mathcal P) = h$.
- Pak existuje rozklad množiny $X, X = A_{1} \cup A_{2} \cup \dots \cup A_{h}$, kde $A_{i}, i = 1\dots,h$ je antiřetězec.
- Navíc, neexistuje rozklad množiny $X$ na méně než $h$ antiřetězců.

## Řetězce a antiřetězce

Mějme POSET $(X, \leq)$, podmnožinu $C \subseteq X$ nazveme **řetězcem** (řetízkem), pokud platí, že každé 2 různé prvky $x, y \in C$ jsou porovnatelné.

Naopak podmnožinu $A \subseteq X$ nazveme **antiřetězcem** (antiřetízkem), pokud jsou každé 2 různé prvky $x, y \in A$ neporovatelné.

**Výška POSETu**
- označíme $\text{height}(\mathcal P)$, je největší $h$ takové, že existuje řetězec $h$ prvků v $\mathcal P$

**Šířka POSETu**
- označíme $\text{width}(\mathcal P)$, je největší $w$ takové, že existuje antiřetězec $w$ prvků v $\mathcal P$