# Booleova algebra

**Distributivní komplementární svaz** se nazývá **Booleův svaz** nebo **Booleova algebra**.

Operace spojení $\vee$ se značí symbolem $+$, operace průsek $\wedge$ symbolem $\cdot$.

Obsahuje $2^n$ prvků. (2, 4, 8, 16, ...)

## Booleovský kalkulus

Nechť $X$ je Booleova algebra, $a, b, c \in X$. Potom platí:

|     | spojení                                        | průsek                                          | vlastnost           |
| --- | ---------------------------------------------- | ----------------------------------------------- | ------------------- |
| S1  | $a+a=a$                                        | $a\cdot a=a$                                    | idempotentnost      |
| S2  | $a+b=b+a$                                      | $a\cdot b=b\cdot a$                             | komutativita        |
| S3  | $a+(b+c)=(a+b)+c$                              | $a\cdot (b\cdot c) = (a\cdot b)\cdot c$         | asociativita        |
| S4  | $a+(a\cdot b) = a$                             | $a\cdot(a+b)=a$                                 | absorbce            |
| D   | $a\cdot(b+c)=(a\cdot b)+(a\cdot c)$            | $a+(b\cdot c)=(a+b)\cdot(a+c)$                  | distributivita      |
| N1  | $a+0=a$                                        | $a\cdot1=a$                                     | neutrální prvky     |
| N2  | $a+1=1$                                        | $a\cdot0=0$                                     | neutrální prvky     |
| K1  | $\overline 0 = 1$                              | $\overline 1 = 0$                               | komplementy         |
| K2  | $a + \overline a = 1$                          | $a \cdot \overline a = 0$                       | komplementarita     |
| K3  | $\overline{(\overline a)} = a$                 |                                                 | involutornost       |
| K4  | $\overline{a+b}=\overline a \cdot \overline b$ | $\overline{a\cdot b}=\overline a + \overline b$ | De Morganovy zákony |

## Atom

Nechť $X$ je Booleova algebra. Nenulový prvek $a \in X$ takový, že pro každý prvek $x \in X, x\neq a$ platí $x \wedge a = 0$ nebo $x \wedge a = a$, se nazývá atom algebry $X$.
- tedy dolní hranice prvku $a$ a libovolného $x$ je tedy $0$ nebo $a$

Atomy existují v každé Booleově algebře. Existovat nemusí pouze v nekonečných Booleových algebrách.

Nechť $X$ je Booleova algebra, $x \in X$. Potom existují prvky $y, z \in X$ takové, že $y\neq x, z\neq x,y \vee z = x$ právě tehdy, když $x$ není ani nulový prvek ani atom $X$.
- prvky $x, y, z$ jsou rozdílné a horní hranice $y, z$ je $x$ tehdy, pokud $x$ není nulový ani atom

Nechť $X$ je konečná Booleova algebra a $x \in X$ je libovolný nenulový prvek, potom platí, že
- $x = a_{1} \vee a_{2} \vee \dots \vee a_{k}$,

kde $a_{1}, \dots, a_{k}$ jsou všechny atomy $X$, pro které $a_{i} \leq x, i =1, \dots, k$.

TODO: 5. přednáška

## Direktní součin Booleovy algebry

Nechť $B_{1} = (X, \leq_{1}), B_{2} = (Y, \leq_{2})$ jsou Booleovy algebry. Potom se **direktním součinem** Booleových algeber $B_{1} \times B_{2}$ rozumí Booleova algebra $B = B_{1} \times B_{2} = (X \times Y, \leq)$, kde platí $(a_{1}, a_{2}) \leq (b_{1}, b_{2}) \iff a_{1} \leq_{1} b_{1} \wedge a_{2} \leq_{2} b_{2}$.

**Příklad**:  Mějme Booleovy algebry $B_{1}, B_{2}$.
- $B_{1} = \{0_{1}, 1_{1}\} \quad B_{2} = \{0_{2}, 1_{2}\}$
- $B_{1} \times B_{2} = \{(0_{1}, 0_{2}), (0_{1}, 1_{2}), (1_{1}, 0_{2}), (1_{1}, 1_{2})\}$

**Důsledek**: Každá Booleova algebra $B$ je izomorfní s $B_{2}^n$, kde $n$ je počet atomů $B$.
- $B_{2}^2 = B_{2} \times B_{2}, \quad B_{2}^3 = B_{2} \times B_{2} \times B_{2}$
- $B_{2}^4$ - hyperkrychle (4-rozměrná)
