# Laplaceova matice

Nechť $G$ je neorientovaný graf s vrcholy $V = \{v_{1}, \dots, v_{n}\}$ a $\vec{G}$ nějaké jeho orientace bez smyček a násobných hran. Dále položme
- $L = A(\vec{G}) \cdot (A(\vec{G}))^T \quad$ (tzv. **Laplaceova matice** grafu $G$).
- $A(\vec{G})$ je indukovaná matice libovolné orientace neorientovaného grafu.

Potom pro prvky čtvercové matice $L = (l_{ij})$ řádu $n$ platí:

$l_{ij} = \begin{cases} \text{d}(v_{i}) & \text{pokud } i=j, \\ -1 & \text{pokud } v_{i}v_{j} \in E(G), \\ 0 & \text{jinak,} \end{cases}$

kde $\text{d}(v_{i})$ je stupeň vrcholu $v_{i}$.

Navíc platí, že matici $L' = M_{R}(\vec{G}) \cdot (M_{R}(\vec{G}))^T$ získáme vypuštěním posledního řádku a sloupce z matice $L$.

Kolik koster má úplný graf na $n$ vrcholech?
- Úplný graf na $n \geq 2$ vrcholech má $n^{n-2}$ různých koster.

# Počet koster

**Cauchy-Binetova věta**: Nechť $B$ je matice o rozměrech $r\times s$, kde $r \leq s$. Potom platí, že

- $\displaystyle\det(B\cdot B^T) = \sum_{I} (\det B_{I})^2,$

kde $I$ probíhá všechny $r$-prvkové množiny sloupců a $B_I$ je čtvercová podmatice matice $B$, určená sloupci z množiny $I$.

**Věta**: Nechť $\vec{G}$ je slabě souvislý orientovaný graf bez smyček a $A = M_{R}(\vec{G})$. Potom **počet koster** grafu $\vec{G}$ **je roven determinantu** matice $A \cdot A^T$.