# Acyklické grafy

Graf $\vec{G}$ je **acyklický**, jestliže $\vec{G}$ neobsahuje jako podgraf žádný cyklus.

**Sledová relace** $x \sim y$ na vrcholech $x, y \in V(\vec{G})$ acyklického orientovaného grafu:
- reflexivní
	- $x \sim x$ - sled nulové délky
- antisymetrická
	- $x \sim y \wedge y \sim x \implies x = y$ - jednalo by se jinak o cyklus
- tranzitivní
	- $x \sim y \wedge y \sim z \implies x \sim z$

**Pozorování**: Každý POSET odpovídá sledové relaci nějakého acykl. orientovaného grafu a naopak. (bijekce)
- minimální prvky: $d^\text{in}(v) = 0$
	- pouze z něj hrany vystupují
- maximální prvky: $d^\text{out}(v) = 0$
	- pouze do něj hrany vstupují

**Pozorování**: Každý podgraf acyklického grafu je acyklický. (acyklicita je dědičná)
- $\implies$ každý acyklický graf má (lineární) **topologické uspořádání vrcholů**
	-  odtrhávání vstupních vrcholů a jejich postupné číslování
	- dají se očíslovat od $1$ (nemá žádnou vstupující hranu) po $n$ (nemá žádnou vystupující hranu)
	- $(i, j) \in E(\vec{G}) \implies i < j$

**Pozorování**: Vrcholy acyklického grafu lze lineárně uspořádat.

**Věta**: Vlastnosti acyklického grafu
- kondenzace $\vec{G}^c$ je acyklický graf
- $\vec{G}$ je silně souvislý $\iff \vec{G}^c$ má jediný vrchol
- $\vec{G}$ je acyklický $\iff$ $\vec{G}^c = \vec{G}$

# Nilpotentnost matice

**Tvrzení**: Orientovaný graf $\vec{G}$ je acyklický právě, pokud je nějaká mocina jeho **matice sousednosti** $A(\vec{G})$ nulová.
- $\exists \, k \geq 0 : A^k(\vec{G}) = 0$

Matice je **nilpotentní**, jestliže je nějaká její mocnina nulová.

Ověříme tím, že sestavíme graf a zjistíme, jestli je acyklický.